#include "refobj.h"
#include "func.h"
#include "varstore.h"
#include "parser.h"
#include "program.h"

int main(int argc, char **argv) {
    char *fname = NULL;
    if(argc == 1)
        fname = NULL;
    else if(argc == 2)
        fname = argv[1];
    else
        ON_FALSE_EXIT(0, strmsg("Usage: %s [program_file]", argv[0]));

    //parse
    program_t *pgm = parse(fname);
    //pgm->print(pgm);

    //compile
    pgm->exec(pgm);

    //release program
    pgm->ref.release(&pgm->ref);
    refobj_check_dealloc();
    
    return 0;
}

