//
// expr_comp.c
//  comparators
//

#include "expr.h"
#include "expr_opr.h"

//equal
//
static void oper_eq() { 
    //TODO: implement this function
    //hint: use cmpq, sete, ... and movzbq to get the result to rax
}
expr_t *expr_make_eq(expr_t *a, expr_t *b) {
    return expr_make_opr(a, b, "==", oper_eq);
}

//not equal
//
static void oper_ne() { 
    //TODO: implement this function
    //hint: use cmpq, setne, ... and movzbq to get the result to rax
}
expr_t *expr_make_ne(expr_t *a, expr_t *b) {
    return expr_make_opr(a, b, "!=", oper_ne);
}

//greater than or equal to
//
static void oper_ge() { 
    //TODO: implement this function
    //hint: use cmpq, setge, ... and movzbq to get the result to rax
}
expr_t *expr_make_ge(expr_t *a, expr_t *b) {
    return expr_make_opr(a, b, ">=", oper_ge);
}

//greater than
//
static void oper_gt() { 
    //TODO: implement this function
    //hint: use cmpq, setg, ... and movzbq to get the result to rax
}
expr_t *expr_make_gt(expr_t *a, expr_t *b) {
    return expr_make_opr(a, b, ">", oper_gt);
}

//less than or equal to
//
static void oper_le() { 
    //TODO: implement this function
    //hint: use cmpq, setle, ... and movzbq to get the result to rax
}
expr_t *expr_make_le(expr_t *a, expr_t *b) {
    return expr_make_opr(a, b, "<=", oper_le);
}

//less than
//
static void oper_lt() { 
    //TODO: implement this function
    //hint: use cmpq, setl, ... and movzbq to get the result to rax
}
expr_t *expr_make_lt(expr_t *a, expr_t *b) {
    return expr_make_opr(a, b, "<", oper_lt);
}
