#ifndef __VARSTORE__
#define __VARSTORE__
#include "list.h"

typedef struct var_store {
    int cnt_param;
    list_t lst;
} var_store_t;

extern void var_store_init(var_store_t *store, int cnt_param);
extern void var_store_destroy(var_store_t *store);
extern int  var_store_has(var_store_t *store, char *name);
extern int  var_store_get(var_store_t *store, char *name);
extern int  var_store_set(var_store_t *store, char *name);
extern int  var_store_parameter_size(var_store_t *store);
extern int  var_store_local_var_size(var_store_t *store);

#endif
